<script setup lang="ts">
import { ref, onMounted, reactive, watch } from "vue";
import type { QTableProps } from "quasar";
import { useQuasar } from "quasar";

import http from "@/plugins/http";
import config from "@/app.config";
import { checkPermission } from "@/utils/permissions";
import { useCounterMixin } from "@/stores/mixin";
import { usePagination } from "@/composables/usePagination";

import type { DataKPIGroup } from "@/modules/01_masterdata/interface/response/Main";

import dialogHeader from "@/components/DialogHeader.vue";

const $q = useQuasar();
const mixin = useCounterMixin();
const {
  dialogRemove,
  dialogConfirm,
  showLoader,
  hideLoader,
  messageError,
  success,
} = mixin;
const { pagination, params, onRequest, checkAndUpdatePage } = usePagination(
  "",
  fetchData
);

const columns = ref<QTableProps["columns"]>([
  {
    name: "nameGroupKPI",
    align: "left",
    label: "รายการกลุ่มงาน",
    sortable: true,
    field: "nameGroupKPI",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
]);
const visibleColumns = ref<string[]>(["nameGroupKPI"]);

const modal = ref<boolean>(false); // เปิด/ปิด dialog
const rows = ref<DataKPIGroup[]>([]); // ข้อมูลกลุ่มงาน
const keyword = ref<string>(""); // คำค้นหา
const groupName = ref<string>(""); // ชื่อกลุ่มงาน
const editStatus = ref<boolean>(false); // สถานะการแก้ไข
const editId = ref<string>(""); // รหัสกลุ่มงานที่ต้องการแก้ไข

/** ฟังก์ชันดึงข้อมูลกลุ่มงาน */
async function fetchData() {
  showLoader();
  await http
    .get(config.API.kpiGroup + "/edit", {
      params: {
        ...params.value,
        keyword: keyword.value.trim(),
      },
    })
    .then(async (res) => {
      const result = res.data.result;
      pagination.value.rowsNumber = result.total;
      rows.value = result.data;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/** ฟังก์ชันบันทึกการเพิ่มข้อมูลกลุ่มงาน */
async function addData() {
  showLoader();
  await http
    .post(config.API.kpiGroup, {
      nameGroupKPI: groupName.value,
    })
    .then(async () => {
      await fetchData();
      success($q, "บันทึกข้อมูลสำเร็จ");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ฟังก์ชันบันทึกการแก้ไขข้อมูลกลุ่มงาน
 * @param id รหัสกลุ่มงานที่ต้องการแก้ไข
 */
async function editData(id: string) {
  showLoader();
  await http
    .put(config.API.kpiGroupById(id), {
      nameGroupKPI: groupName.value,
    })
    .then(async () => {
      await fetchData();
      success($q, "บันทึกข้อมูลสำเร็จ");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ฟังก์ชันลบข้อมูลกลุ่มงาน
 * @param id รหัสกลุ่มงานที่ต้องการลบ
 */
async function deleteData(id: string) {
  showLoader();
  await http
    .delete(config.API.kpiGroupById(id))
    .then(async () => {
      await checkAndUpdatePage(rows.value.length);
      await fetchData();
      success($q, "ลบข้อมูลสำเร็จ");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/** ฟังก์ชันเปิด dialog เพิ่มข้อมูล */
function onAdd() {
  modal.value = true;
}

/** ฟังก์ชันปิด dialog */
function closeDialog() {
  modal.value = false;
  editStatus.value = false;
  groupName.value = "";
}

/**
 * ฟังก์ชันเปิด dialog แก้ไข
 * @param data ข้อมูลกลุ่มงานที่ต้องการแก้ไข
 */
function onEdit(data: DataKPIGroup) {
  modal.value = true;
  editStatus.value = true;
  groupName.value = data.nameGroupKPI;
  editId.value = data.id;
}

/** บันทึกข้อมูล */
async function onSubmit() {
  dialogConfirm(
    $q,
    async () => {
      editStatus.value ? await editData(editId.value) : await addData();
      closeDialog();
    },
    "ยืนยันการบันทึกข้อมูล",
    "ต้องการยืนยันการบันทึกข้อมูลนี้หรือไม่ ?"
  );
}

/** ฟังก์ชันดึงข้อมูลกลุ่มงานใหม่ */
function fetchNewList() {
  pagination.value.page = 1;
  fetchData();
}

/** lifecycle hook */
onMounted(() => {
  fetchData();
});
</script>

<template>
  <q-toolbar style="padding: 0">
    <q-btn
      v-if="checkPermission($route)?.attrIsCreate"
      flat
      round
      color="primary"
      icon="add"
      @click="onAdd()"
    >
      <q-tooltip> เพิ่มข้อมูล </q-tooltip>
    </q-btn>
    <q-space />
    <div class="row q-gutter-sm">
      <q-input
        outlined
        dense
        v-model="keyword"
        label="ค้นหา"
        @keyup.enter="fetchNewList()"
      >
        <template v-slot:append> <q-icon name="search" /> </template
      ></q-input>
      <q-select
        v-model="visibleColumns"
        multiple
        outlined
        dense
        options-dense
        :display-value="$q.lang.table.columns"
        emit-value
        map-options
        :options="columns"
        option-value="name"
        style="min-width: 140px"
      />
    </div>
  </q-toolbar>

  <p-table
    ref="table"
    :columns="columns"
    :rows="rows"
    row-key="id"
    flat
    bordered
    :paging="true"
    dense
    class="custom-header-table"
    :rows-per-page-options="[1, 10, 25, 50, 100]"
    :visible-columns="visibleColumns"
    @request="onRequest"
    v-model:pagination="pagination"
  >
    <template v-slot:header="props">
      <q-tr :props="props">
        <q-th auto-width />
        <q-th v-for="col in props.cols" :key="col.name" :props="props">
          <span class="text-weight-medium">{{ col.label }}</span>
        </q-th>
      </q-tr>
    </template>
    <template v-slot:body="props">
      <q-tr :props="props">
        <q-td auto-width>
          <q-btn
            v-if="
              checkPermission($route)?.attrIsGet &&
              checkPermission($route)?.attrIsUpdate
            "
            color="edit"
            flat
            dense
            round
            class="q-mr-xs"
            icon="edit"
            clickable
            @click="onEdit(props.row)"
          >
            <q-tooltip>แก้ไขข้อมูล</q-tooltip>
          </q-btn>
          <q-btn
            v-if="checkPermission($route)?.attrIsDelete"
            color="red"
            flat
            dense
            round
            icon="mdi-delete"
            clickable
            @click.stop="
              dialogRemove($q, async () => await deleteData(props.row.id))
            "
            v-close-popup
          >
            <q-tooltip>ลบข้อมูล</q-tooltip>
          </q-btn>
        </q-td>
        <q-td v-for="col in props.cols" :key="col.id">
          {{ col.value }}
        </q-td>
      </q-tr>
    </template>
  </p-table>

  <q-dialog v-model="modal" persistent>
    <q-card flat bordered style="min-width: 50vh">
      <q-form greedy @submit.prevent @validation-success="onSubmit">
        <dialog-header
          :tittle="editStatus ? 'แก้ไขกลุ่มงาน' : 'เพิ่มกลุ่มงาน'"
          :close="closeDialog"
        />
        <q-separator />
        <q-card-section>
          <q-input
            label="กลุ่มงาน"
            v-model="groupName"
            outlined
            dense
            class="inputgreen"
            :rules="[(val:string) => !!val || `${'กรุณากรอกกลุ่มงาน'}`,]"
            hide-bottom-space
          />
        </q-card-section>
        <q-separator />
        <q-card-actions align="right">
          <q-btn
            type="submit"
            for="#submitForm"
            class="q-px-md items-center"
            color="public"
            label="บันทึก"
          >
            <q-tooltip>บันทึกข้อมูล</q-tooltip>
          </q-btn>
        </q-card-actions>
      </q-form>
    </q-card>
  </q-dialog>
</template>
